#include <GL/glut.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include "traqueboule.h"
#include "argumentParser.h"


// Utilis pour essayer diffrents types de rendu
// Utilis via le paramtre "-t" en ligne de commande
// LASTTYPE N'EST UTILISE QUE POUR CONNAITRE LA FIN DE LA LISTE
enum { TEST_ANTIA=0, ANTIA=1, DOF=2, STEN=3
	, LASTTYPE
};
unsigned int type = TEST_ANTIA;

unsigned int W_fen = 300;  // largeur fenetre
unsigned int H_fen = 300;  // hauteur fenetre


// Utilis pour dcaler lgerement la camra
// dans le cadre du blur
float pix_xoff = 0.0;
float pix_yoff = 0.0;


//
// FIN DES HEADERS
//



/**
 * Applique une transformation de la matrice model view
 * pour placer la scne
 */
void deplacerScene( )
{
	glRotatef( 30.0, 1.0, 0.0, 0.0 );
	glRotatef( 30.0, 0.0, 1.0, 0.0 );
}

void dessinerScene()
{
	glEnable( GL_SMOOTH );
	
	deplacerScene( );
	
	glPushMatrix();
	glColor3f( 1.0, 1.0, 0.0 );
	glutSolidCube( 2.0 );
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef( -1.5, 0.3, -3.4 );
	glColor3f( 0.0, 1.0, 0.2 );
	glutSolidSphere( 1.2, 10, 10 );
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef( 25.5, -10.0, -20.0 );
	glRotatef( -66, 1.0, 0.4, 0.0 );
	glColor3f( 0.3, 0.4, 0.7 );
	glutSolidCube( 10.0 );
	glPopMatrix();
	
	glPushMatrix();
	glTranslatef( -2.3, 1.9, 3.8);
	glRotatef( 90, 1.0, 0.0, 0.0 );
	glColor3f( 0.9, 0.2, 0.1 );
	glutSolidTorus( 0.2, 0.5, 50, 50 );
	glPopMatrix();
}






/**
 * Appel des diffrentes fonctions de dessin
*/
void dessiner( )
{
	switch( type )
	{
	case TEST_ANTIA:
	case ANTIA:
	case DOF:
	case STEN:

		dessinerScene();
		break;
	default:
		dessinerScene(); // Par dfaut
		break;
	}
}






/**
 * Initiliasation et suppression
 */

void initDonnees()
{
}

void finDonnees()
{
}



/**
 * Initialise la/les lumires
 */

void initLights( )
{
    // Active la gestion de la lumire
    glEnable( GL_LIGHTING );
    // Active la premire lumire
    glEnable( GL_LIGHT0 );
    // Pour plus tard : glColor3f modifie le diffus du matriaux
    glEnable(GL_COLOR_MATERIAL);


    // Dfini l'clairage de la premire lampe
    float LightPos0[4] = {0,0,0,1};     // Position
    float LightDiff0[4] = {1,1,1,1};    // Couleur diffuse
    //float LightDiff0[4] = {1,0,1,1};  // Couleur diffuse (2)
    float LightSpec0[4] = {1,1,1,1};    // Couleur spculaire

    // "glLightfv" :  la fin "fv" signifie "float" et "pointeur"
    // c'est--dire que le dernier paramtre sera un tableau de 4 floats
    glLightfv(GL_LIGHT0, GL_POSITION, LightPos0);
    glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiff0);
    glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpec0);

}


/**
 * Camra
 **************************/

/**
 * Paramtres de camra
 * Devraient tre fixes
 */
float zCamera = 5.0;

// Rduit les distances pour pouvoir voir de prs
float scale = 0.01;
float znear = 2.0*scale;
float zfar = 200.0;
float left = -scale;
float right = scale;
float bottom = -scale;
float top = scale;

// A quelle distance faire le focus
float focus = 3.5;


void placerCamera( float x, float y, float z );

/**
 * Dfini la camra perspective
 */
void definirCamera( float pix_xoffset, float pix_yoffset, float focus)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
    
	GLint viewport[4];

	// Rcupre les infos du vieport (=> l'aspect vu au TP5)
	// viewport[2] donne la taille en pixels de la largeur
	// viewport[3] de la hauteur
	glGetIntegerv(GL_VIEWPORT, viewport);
	float aspect = ((float)viewport[2])/((float)viewport[3]);	// l'aspect
	
	// On utilise aspect* car lorsque l'on redimensionne la fentre, on change "left" et "right"
	// Pour conserver les proportions
	float dx = aspect * (right - left)/viewport[2];	// la largeur d'un pixel dans le repre monde
	float dy = (top - bottom)/viewport[3];	// la hauteur
	
	float decx = 0.0;
	float decy = 0.0;
	
	if( (type == TEST_ANTIA) || (type == ANTIA) )
	{
		decx = -pix_xoffset * dx;	// On dcalera les plans left et right de pix_xoffset * la largeur d'un pixel
		decy = -pix_yoffset * dy;
	}
	else if( type == DOF )
	{
   		decx = -(pix_xoffset*znear/focus);
   		decy = -(pix_yoffset*znear/focus);
	}
   
	
    	glFrustum(	aspect*left + decx, aspect*right + decx,
			bottom + decy, top + decy,
			znear, zfar );
			
			
	glMatrixMode(GL_MODELVIEW);
	if( (type == TEST_ANTIA) || (type == ANTIA) || (type == STEN) )
	{
		placerCamera( 0.0, 0.0, -zCamera );
	}
	else if( type == DOF )
	{
		placerCamera( -pix_xoffset, -pix_yoffset, -zCamera );
	}

}

void placerCamera( float x, float y, float z )
{
	// On doit tre dans la matrice MODEL_VIEW
	// cad : la matrice perspective doit tre dfinie
	glLoadIdentity();
	initLights();
	
	
	// Par dfaut,  commenter plus tard
	// Recule la camra
	glTranslatef( x, y, z );
	
	tbVisuTransform();
}













/**
 * Exercice du stencil buffer
 */
void definirPochoir( float r )
{
	glDisable( GL_LIGHTING );

	// Le stencil est effac  0
	glClearStencil(0);
	glClear( GL_STENCIL_BUFFER_BIT );
	
	// Mise en route du stencil
	glEnable(GL_STENCIL_TEST);
	
	// GL_NEVER signifie que l'on ne dessine jamais dans le COLOR_BUFFER
	// donc, tout ce qui suit, et jusqu' nouvel ordre, ne sera pas dessin dans l'image
	glStencilFunc(GL_NEVER, 0, 0xFFFF);
	
	// GL_INCR indique que l'on incrmente la valeur du stencil dans tous les cas le stencil buffer
	// cd ds qu'il devrait y avoir un pixel  dessiner
  	glStencilOp(GL_INCR, GL_INCR, GL_INCR);
	
	// Dessiner le masque pour remplir le stencil buffer
	// On dessine une sphere de rayon r au centre
	// (remise  0 des matrices)
   	glMatrixMode( GL_PROJECTION );
	glLoadIdentity();
   	glMatrixMode( GL_MODELVIEW );
	glLoadIdentity();
	
	// Dessine le gros cercle
	glutSolidSphere( r, 100, 100 );
	
	// Dessine le petit cercle  l'intrieur
	glutSolidSphere( r*0.1, 100, 100 );

	// Dessine les traits horizontaux et verticaux
	glStencilOp(GL_ZERO, GL_ZERO, GL_ZERO);
	glLineWidth( 2 );
	glBegin( GL_LINES );
	glVertex3f( -r*0.01, 0.0, 0.0 );
	glVertex3f( r*0.01, 0.0, 0.0 );
	glVertex3f( 0.0, -r*0.01, 0.0 );
	glVertex3f( 0.0, r*0.01, 0.0 );

	glEnd();
		

}











void display(void);
void reshape(int w, int h);
void keyboard(unsigned char key, int x, int y);

/**
 * Programme principal
 */
int main(int argc, char** argv)
{
	
    animal::parse("Camra. Voici la liste des options: ")
    .option(&W_fen,'L',"Largeur","largeur de la fentre en pixels")
    .option(&H_fen,'H',"Hauteur","hauteur de la fentre en pixels")
    .option(&type,'t',"type","type de rendu")
    (argc,argv);

    initDonnees( ); 
    
    glutInit(&argc, argv);

    // couches du framebuffer utilisees par l'application
    glutInitDisplayMode( GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH | GLUT_ACCUM  | GLUT_STENCIL );

    // position et taille de la fenetre
    glutInitWindowPosition(200, 100);
    glutInitWindowSize(W_fen,H_fen);
    glutCreateWindow(argv[0]);

    

	
        tbInitTransform();     // initialisation du point de vue
    initLights();

    // cablage des callback
    glutReshapeFunc(reshape);
    glutKeyboardFunc(keyboard);
    glutDisplayFunc(display);
    glutMouseFunc(tbMouseFunc);    // traqueboule utilise la souris
    glutMotionFunc(tbMotionFunc);  // traqueboule utilise la souris
    glutIdleFunc( display );

    // lancement de la boucle principale
    glutMainLoop();
    
    finDonnees();
    
    return 0;  // instruction jamais excute
}

int N = 1;	// => Nombre de fois o il faudra dessiner dans le buffer d'accumulation









/**
 * Fonctions de gestion opengl  ne pas toucher
 */
// Actions d'affichage
// Ne pas changer
void display(void)
{
    // Details sur le mode de trac
    glEnable( GL_DEPTH_TEST );            // effectuer le test de profondeur
    glEnable(GL_CULL_FACE);
    glCullFace(GL_BACK);
    glPolygonMode(GL_FRONT,GL_FILL);
    glPolygonMode(GL_BACK,GL_LINE);

    
    
    glClearColor (0.0, 0.0, 0.0, 0.0);
    glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT );
    
    if( type == TEST_ANTIA )
    {
	definirCamera( pix_xoff, pix_yoff, focus );
	dessiner( );
    }
    else if( (type == ANTIA) || (type == DOF) )
    {
    	// Effacer le buffer d'accumulation
    	glClear(GL_ACCUM_BUFFER_BIT);
    
	
	// Premire image
    	// Il faut bien sr effacer le depth buffer et l'image (color buffer)
	glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT);
	// Maintenant dcaler la camra
	// remplacer pix_xoff et pix_yoff par les valeurs souhaites
	definirCamera( pix_xoff, pix_yoff, focus );
	dessiner( );
	// Rcupre le COLOR_BUFFER et le transfre dans l'ACCUM_BUFFER
	// en multipliant au pralable la valeur des pixels par 1.0/N
	glAccum(GL_ACCUM, 1.0/N);
	
	// Deuxime image
	glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT);
	definirCamera( pix_xoff, pix_yoff, focus );
	dessiner( );
	glAccum(GL_ACCUM, 1.0/N);
	
	// etc...

   
   	// Maintenant recopie l'ACCUM_BUFFER vers le COLOR_BUFFER
   	glAccum (GL_RETURN, 1.0);
   }
   else if( type == STEN )
   {
	definirPochoir( 1.0 );
	// Maintenant le STENCIL est rempli avec pour valeurs :
	// 0  l'exterieur de l'ojectif : ne rien dessiner
	// 1  l'intrieur du grand cercle mais  l'exterieur du petit
	// 2  l'intrieur du petit cercle
	
	glEnable( GL_LIGHTING );
  
	glClear( GL_COLOR_BUFFER_BIT  | GL_DEPTH_BUFFER_BIT);
	
	// Si le stencil est gal  1, alors on fait tout normalement
	// car on est dans le grand cercle
  	glStencilFunc(GL_EQUAL, 1, 0xFFFF);
  	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	definirCamera( 0.0, 0.0, 0.0 );
	dessiner( );
	
	// Si le stencil est gal  1, alors on fait tout normalement
	// mais pas  la mme chelle
	// car on est dans le petit cercle
  	glStencilFunc(GL_EQUAL, 2, 0xFFFF);
  	glStencilOp(GL_KEEP, GL_KEEP, GL_KEEP);
	definirCamera( 0.0, 0.0, 0.0 );
	glScalef( 0.75, 0.75, 0.75 );
	dessiner( );
   }
    
    glutSwapBuffers();
    
}


// pour changement de taille ou desiconification
void reshape(int w, int h)
{
	W_fen = w;
	H_fen = h;
	
	// Change effectivement la taille de la fentre openGL
	glViewport(0, 0, (GLsizei) w, (GLsizei) h);
	
	glutPostRedisplay();
}


// On utilise ce parametre comme modificateur des variables
// Il peut tre changer avec '+' et '-'
float ddata = 0.5;

// prise en compte du clavier
void keyboard(unsigned char key, int mousex, int mousey)
{
    //printf("key %d pressed at %d,%d\n",key,mousex,mousey);
    //fflush(stdout);
    switch (key)
    {
    case 27:     // touche ESC
        exit(0);
	
    case 't':
    	type = (type+1)%(LASTTYPE);
	break;

    case 'X':
    	pix_xoff += ddata;
	break;
    case 'x':
    	pix_xoff -= ddata;
	break;
    case 'Y':
    	pix_yoff += ddata;
	break;
    case 'y':
    	pix_yoff -= ddata;
	break;

    case '+':
    	ddata *= 1.1;
	fprintf( stderr, "ddata = %f\n", ddata );
	break;
    case '-':
    	ddata /= 1.1;
	fprintf( stderr, "ddata = %f\n", ddata );
	break;
	
    case 'f':
    	focus = fmax(ddata, focus-ddata);
	break;
    case 'F':
        focus += ddata;
	break;


    }
    
    fprintf( stderr, "Focus at %f\n", focus ) ;
 
}

